:h1. The SpHyDir Idea
:p.

SpHyDir is designed to behave like the OS/2 Workplace, and to
interact with it. However, SpHyDir is an ordinary application
program written in VX-Rexx, not a DLL written to extend the
Workplace environment. SpHyDir objects are created while the
application is running and they disappear when the program ends.
They cannot be dragged out of the SpHyDir windows to the desktop
(except to the "Shredder" which signals SpHyDir to delete them).
:p.

SpHyDir doesn't have an Open File dialog. Such dialogs are
rather ugly when the same files can be more easily located in
Workplace folders. SpHyDir opens a file when a file icon is
dropped into the Workarea.
:p.

The OS/2 Workplace Shell folders that contain files and other
folders. This view stops at the individual file. Normally when
you open a file you run the system editor, a word processor, or
a spreadsheet. However, when an HTML file is dragged over and
dropped on the open SpHyDir workarea window, it opens up and
presents a tree of document elements. This gives the impression
that the HTML File was itself some kind of Folder that contained
internal components.
:artwork name='WORKAREA.BMP'.
:p.

The document is presented as an ordered sequence of components
organized in a logical tree. There are different icons for each
type of component&colon. Sections, Paragraphs, Images, Numbered
and Unnumbered Lists, Preformatted Example, and so on. The tree
structure reflects the view that some components "contain" other
components. For example, a chapter or section contains all the
other elements that fall within a particular topic. Each list
contains a sequence of points.
:p.

SpHyDir was influenced by some of the discussion about compound
documents and OpenDoc. OpenDoc views a document as a collection
of component parts. There are text parts, image parts, table
parts, and so on. At first it seemed that OpenDoc technology
would be the right tool to use. However, OpenDoc assumes that
each part can be precisely positioned in two dimensions on the
viewing area. Web documents, however, have to be filtered
through HTML which only allows the linear definition of the
document as an ordered sequence of components.
:p.

The SpHyDir presentation of the document as an ordered, but
structured, sequence of component objects seems to be the best
compromise between HTML constraints and modern object-oriented
compound document thinking. Making the object behavior
consistent with the OS/2 Workplace, and then interacting with
real Workplace objects, simplifies the user interface.
